# Copyright (C) 1999 by Juergen Pfeifer
# Ada for Linux Team (ALT)
#
# Permission is hereby granted, free of charge, to any person obtaining a  
# copy of this software and associated documentation files (the            
# "Software"), to deal in the Software without restriction, including      
# without limitation the rights to use, copy, modify, merge, publish,      
# distribute, distribute with modifications, sublicense, and/or sell       
# copies of the Software, and to permit persons to whom the Software is    
# furnished to do so, subject to the following conditions:                 
#                                                                          
# The above copyright notice and this permission notice shall be included  
# in all copies or substantial portions of the Software.                   
#                                                                          
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS  
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF               
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.   
# IN NO EVENT SHALL THE ABOVE COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,   
# DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR    
# OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR    
# THE USE OR OTHER DEALINGS IN THE SOFTWARE.                               
#                                                                          
# Except as contained in this notice, the name(s) of the above copyright   
# holders shall not be used in advertising or otherwise to promote the     
# sale, use or other dealings in this Software without prior written       
# authorization.          
#
# ---------------------------------------------------------------------------
#  Author: Jrgen Pfeifer <Juergen.Pfeifer@T-Online.de>
# ---------------------------------------------------------------------------
#
# GNU Ada RPM Packaging for FLORIST
#
%define        GNAT_TARGET_ARCH    i386
%define        COMPAT_TARGET_ARCH  i386 i486 i586 i686
%define        GNAT_TARGET_OS      Linux
%define        TARGET_OS           linux 
#
%define        BASE_NAME           gnat
%define        GNAT_PKG_NAME       gnat-3.11p
%define        GNAT_VERSION        3.11p
%define        GNAT_PKG_VERSION    1
%define        GNAT_PKG_RELEASE    11
%define        GCC_VERSION         2.8.1
%define        GDB_VERSION         4.17
#
%define        DEF_USER       bin
%define        DEF_GROUP      bin
#
%define        BASE_VERSION   gcc-%{GCC_VERSION}
#
%define        CFG_PREFIX     /usr
%define        ADA_ROOT       /lib/gnat
%define        ADA_BASE       %{CFG_PREFIX}%{ADA_ROOT}
#
%define        GNAT_SO_MAJOR  %{GNAT_PKG_VERSION}
%define        GNAT_SO_MINOR  %{GNAT_PKG_RELEASE}
#
%define        RPM_C_FLAGS     -O3 -m486 -fomit-frame-pointer
%define        RPM_ADA_FLAGS   -gnatpn
#
%define        THREADLIBS     -lpthread
#
%define        GNAT_NAME      gnat-%{GNAT_VERSION}
%define        GNAT_SO        %{GNAT_NAME}
%define        GNAT_DIR       %{ADA_BASE}/%{GNAT_NAME}
#
%define        AINC_NAME      adainclude
%define        AINC_DIR       %{ADA_BASE}/%{AINC_NAME}
#
%define        ALIB_NAME      adalib
%define        ALIB_DIR       %{ADA_BASE}/%{ALIB_NAME}
#
%define        ETC_NAME       etc
%define        ETC_DIR        %{ADA_BASE}/%{ETC_NAME}
#
%define        COMPAT_NAME    act_compat-%{GNAT_VERSION}
%define        COMPAT_DIR     %{ADA_BASE}/%{COMPAT_NAME}
#
%define        ASIS_NAME      asis-%{GNAT_VERSION}
%define        ASIS_SO        %{ASIS_NAME}
%define        ASIS_DIR       %{ADA_BASE}/%{ASIS_NAME}
#
%define        GLADE_NAME     glade-%{GNAT_VERSION}
%define        GLADE_DIR      %{ADA_BASE}/%{GLADE_NAME}
#dnl
#
%define        PKG_NAME       florist-3.12w
%define        PKG_VERSION    1
%define        PKG_RELEASE    4
#
%define        FLORIST_BASE   florist
%define        SO_BASE        %{PKG_NAME}
%define        SO_MAJOR       %{PKG_VERSION}
%define        SO_MINOR       %{PKG_RELEASE}
#
%define        FLORIST_DIR    florist-990327
#
# ---------------------------------------------------------------------------
# We restrict the use of this package scipt at the moment to Intel and Linux.
# For sure there are details (compiler options, shared library building)
# that must be fixed for other architectures and OSes.
#
ExclusiveArch: %{COMPAT_TARGET_ARCH}
ExclusiveOS:   %{GNAT_TARGET_OS}
Packager:      Jrgen Pfeifer <Juergen.Pfeifer@t-online.de>
Distribution:  ALT (Ada for Linux Team)
Version:       %{PKG_VERSION}
Release:       %{PKG_RELEASE}
Name:          %{PKG_NAME}
BuildRoot:     /var/tmp/%{PKG_NAME}-%{version}-root
Autoreq:       No
Autoreqprov:   No
# ---------------------------------------------------------------------------
# These are the official sources
Source0:       florist990327.tar.gz
#
# This is our patch
Patch0:        %{PKG_NAME}.diff
#
#  ---------------------------------------------------------------------------
Copyright:     GPL (modified for runtime)
Summary:       Runtime libraries for POSIX 1003.5 Binding (FLORIST)
Summary(de):   Laufzeit-Bibliotheken des POSIX 1003.5 Bindings (FLORIST)
Group:         Libraries
Obsoletes:     %{name}
Provides:      lib%{SO_BASE}.so.%{SO_MAJOR}
Requires:      %{GNAT_PKG_NAME} >= %{GNAT_PKG_VERSION}
Icon:          adarts.gif
Prefix:        %{CFG_PREFIX}
#
%description
This package includes the shared libraries required to run programs compiled
with POSIX 1003.5 support (FLORIST) as long as they are not linked
statically.
#
%description -l de
Dieses Paket enthlt die Shared Libraries die zur Ausfhrung von Programmen
bentigt werden, die mit der POSIX 1005.3 Untersttzung bersetzt wurden 
(FLORIST), sofern diese nicht statisch gebunden wurden.
#
#  ---------------------------------------------------------------------------
%package devel
Summary:       Ada for Linux Team (ALT) POSIX 1003.5 Binding (FLORIST)
Summary(de):   POSIX 1003.5 Binding (FLORIST) des Ada fr Linux Teams (ALT)
Group:         Libraries
Requires:      %{GNAT_PKG_NAME}-devel >= %{GNAT_PKG_VERSION}
Requires:      %{name} = %{version}
Obsoletes:     %{name}-devel
Icon:          adasmall.gif
Prefix:        %{CFG_PREFIX}
#
%description devel
This is a set of Ada packages that allows you to write programs using the
Florida State Universities (FSU) implementation of the Posix 1003.5 
standard for GNU Ada (GNAT). This project has the codename FLORIST.
Posix 1003.5 is the Posix standard for how to bind the Posix functions
to Ada.
#
%description -l de devel
Dies ist ein Sammlung von Ada Pakten die es Ihnen erlaubt, GNU Ada (GNAT)
Programme mit der Implementierung des Posix 1003.5 Standards der Florida
State University (FSU) zu schreiben. Dieses Projekt hat den Codenamen
FLORIST. Posix 1003.5 ist der Posix Standard der beschreibt, wie die
Posix Funktionen von Ada benutzt werden. 
#
#-----------------------------------------------------------------------------
%prep
#=============================================================================
#
%setup -c -q  -n florist
%patch0 -p0 -b .florist
#
#-----------------------------------------------------------------------------
%build
#=============================================================================
# Create the required directory structure for the binary package
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{AINC_DIR}
mkdir -p $RPM_BUILD_ROOT%{ALIB_DIR}
mkdir -p $RPM_BUILD_ROOT/doc/tests
mkdir -p $RPM_BUILD_ROOT%{CFG_PREFIX}/lib

cd %{FLORIST_DIR}
./configure
gnatgcc -c -O3 ada_streams.ads
gnatgcc -c -O3 ada_task_identification.ads
make SONAME=%{SO_MAJOR} SHNAME="%{SO_BASE}" BASENAME="%{FLORIST_BASE}"
for f in ada_*.ali
do
   cp -pf $f floristlib
done
rm -f *.ali *.o
make SONAME=%{SO_MAJOR} SHNAME="%{SO_BASE}" BASENAME="%{FLORIST_BASE}" shared
#
#-----------------------------------------------------------------------------
%install
#=============================================================================
OS=%{TARGET_OS}
#
cd %{FLORIST_DIR}
cp -pf floristlib/system_* $RPM_BUILD_ROOT/doc/tests
rm -rf floristlib/system_*
cp -pf floristlib/*.ad? $RPM_BUILD_ROOT%{AINC_DIR}
cp -pf floristlib/*.ali $RPM_BUILD_ROOT%{ALIB_DIR}
cp -pf floristlib/libflorist.a  $RPM_BUILD_ROOT%{ALIB_DIR}/lib%{FLORIST_BASE}.a
cp -pf floristlib-shared/lib%{SO_BASE}.so.%{SO_MAJOR} \
   $RPM_BUILD_ROOT%{CFG_PREFIX}/lib/lib%{SO_BASE}.so.%{SO_MAJOR}.%{SO_MINOR}
ln -sf lib%{SO_BASE}.so.%{SO_MAJOR}.%{SO_MINOR} \
       lib%{SO_BASE}.so.%{SO_MAJOR}
ln -sf lib%{SO_BASE}.so.%{SO_MAJOR}.%{SO_MINOR} \
   $RPM_BUILD_ROOT%{CFG_PREFIX}/lib/lib%{FLORIST_BASE}.so
ln -sf ../../lib%{SO_BASE}.so.%{SO_MAJOR}.%{SO_MINOR} \
   $RPM_BUILD_ROOT%{ALIB_DIR}/lib%{FLORIST_BASE}.so
strip $RPM_BUILD_ROOT%{CFG_PREFIX}/lib/lib%{SO_BASE}.so.%{SO_MAJOR}.%{SO_MINOR}
#
cp -pf README    $RPM_BUILD_ROOT/doc
cp -pf COPYING	 $RPM_BUILD_ROOT/doc
cp -prf tests    $RPM_BUILD_ROOT/doc
cp -pf gnatprep.config $RPM_BUILD_ROOT/doc/tests
#
if [ -d ${RPM_BUILD_ROOT}%{AINC_DIR} ]; then
  find ${RPM_BUILD_ROOT}%{AINC_DIR} -type f -name '*.ad?' -exec chmod 0444 {} \;
fi
if [ -d ${RPM_BUILD_ROOT}%{ALIB_DIR} ]; then
  find ${RPM_BUILD_ROOT}%{ALIB_DIR} -type f -name '*.ali' -exec chmod 0444 {} \;
  find ${RPM_BUILD_ROOT}%{ALIB_DIR} -type f -name '*.a'   -exec chmod 0444 {} \;
fi
if [ -d ${RPM_BUILD_ROOT}%{CFG_PREFIX}/lib ]; then
  find ${RPM_BUILD_ROOT}%{CFG_PREFIX}/lib -type f -name '*.so*' -exec chmod 0755 {} \;
fi
if [ -d ${RPM_BUILD_ROOT}/doc ]; then
  find ${RPM_BUILD_ROOT}/doc -type f -exec chmod 0444 {} \;
  find ${RPM_BUILD_ROOT}/doc -type d -exec chmod 0755 {} \;
fi
chmod 0755 $RPM_BUILD_ROOT/doc/tests/run_tests_?
#  ---------------------------------------------------------------------------
%pre devel
if [ -f /etc/profile.d/%{BASE_NAME}-rts.sh ]; then
  source /etc/profile.d/%{BASE_NAME}-rts.sh
  if [ ! -z ${GNAT_ROOT} ]; then
    if [ "${GNAT_ROOT}" != "${RPM_INSTALL_PREFIX}" ]; then
      echo "%{BASE_NAME} was installed with --prefix=${GNAT_ROOT}" >&2
      echo "You must use the same prefix with this package." >&2
      exit 1
    fi
  else
    if [ "${RPM_INSTALL_PREFIX}" != "%{CFG_PREFIX}" ]; then
      echo "%{BASE_NAME} was installed without the --prefix option." >&2
      echo "You must do this also with this package." >&2
      exit 1
    fi
  fi
fi
#  ---------------------------------------------------------------------------
%pre
if [ -f /etc/profile.d/%{BASE_NAME}-rts.sh ]; then
  source /etc/profile.d/%{BASE_NAME}-rts.sh
  if [ ! -z ${GNAT_ROOT} ]; then
    if [ "${GNAT_ROOT}" != "${RPM_INSTALL_PREFIX}" ]; then
      echo "%{BASE_NAME} was installed with --prefix=${GNAT_ROOT}" >&2
      echo "You must use the same prefix with this package." >&2
      exit 1
    fi
  else
    if [ "${RPM_INSTALL_PREFIX}" != "%{CFG_PREFIX}" ]; then
      echo "%{BASE_NAME} was installed without the --prefix option." >&2
      echo "You must do this also with this package." >&2
      exit 1
    fi
  fi
fi
#  ---------------------------------------------------------------------------
%post
/sbin/ldconfig
#  ---------------------------------------------------------------------------
%postun
/sbin/ldconfig
#  ---------------------------------------------------------------------------
%files devel
%defattr(-,%{DEF_USER},%{DEF_GROUP})
%doc $RPM_BUILD_ROOT/doc/*
%dir %{CFG_PREFIX}
%dir %{CFG_PREFIX}/lib
%dir %{ADA_BASE}
%dir %{AINC_DIR}
%dir %{ALIB_DIR}
%{AINC_DIR}/*
%{ALIB_DIR}/*
#
#  ---------------------------------------------------------------------------
%files
%defattr(-,%{DEF_USER},%{DEF_GROUP})
%dir %{CFG_PREFIX}
%dir %{CFG_PREFIX}/lib
%{CFG_PREFIX}/lib/lib*.so*
#
#  ---------------------------------------------------------------------------
%clean
rm -rf $RPM_BUILD_ROOT
#  ---------------------------------------------------------------------------
#
%changelog
* Wed Mar 31 1999 Juergen Pfeifer <juergen.pfeifer@t-online.de>
- Rename package, no longer use 3.12w
- Base on new sources from 990327
- Publish as release 4

* Sat Mar 13 1999 Juergen Pfeifer <juergen.pfeifer@t-online.de>
- Published as Release 3

* Mon Mar 08 1999 Juergen Pfeifer <juergen.pfeifer@t-online.de>
- Improved package dependency description

* Sun Mar 07 1999 Juergen Pfeifer <juergen.pfeifer@t-online.de>
- Published as Release 2

* Tue Mar 02 1999 Juergen Pfeifer <juergen.pfeifer@t-online.de>
- Changed shared library and package name to florist

* Mon Mar 01 1999 Juergen Pfeifer <juergen.pfeifer@t-online.de>
- Changed Directory gnu-Ada to plain "gnat"
- Added missing .ali files.
 
* Sun Feb 28 1999 Juergen Pfeifer <juergen.pfeifer@t-online.de>
- Created, Published as Release 1
